/* 
 * Copyright 2007 TKK/Netlab
 * Released under GPLv3. See LICENSE.txt for details. 
 */
package report;

import core.ConnectionListener;
import core.DTNHost;

/**
 * Link connectivity report generator for DTNSim2 input
 */
public class ConnectivityDtnsim2Report extends Report 
	implements ConnectionListener {	
	
	/**
	 * Constructor.
	 */
	public ConnectivityDtnsim2Report() {
		init();
	}
		
	public void hostsConnected(DTNHost h1, DTNHost h2) {
		newEvent();
		write(createTimeStamp() + " " + h1 + " <-> " + h2 + " up");
	}
	
	public void hostsDisconnected(DTNHost h1, DTNHost h2) {
		newEvent();
		write(createTimeStamp() + " " + h1 + " <-> " + h2 + " down");
	}
	
	/**
	 * Creates and returns a "@" prefixed time stamp of the current simulation
	 * time
	 * @return time stamp of the current simulation time
	 */
	private String createTimeStamp() {
		return String.format("@%.2f", getSimTime());
	}
	
}
