/* 
 * Copyright 2007 TKK/Netlab
 * Released under GPLv3. See LICENSE.txt for details. 
 */
package report;

import core.DTNHost;

/**
 * Reports the inter-contact times of nodes (i.e. the time between the
 * end of previous contact and the beginning of a new contact between
 * two hosts).
 */
public class InterContactTimesReport extends ContactTimesReport {
	
	@Override
	public void hostsConnected(DTNHost host1, DTNHost host2) {
		ConnectionInfo ci = this.removeConnection(host1, host2);
		
		if (ci != null) { // connected again
			newEvent();
			ci.connectionEnd();			
			increaseTimeCount(ci.getConnectionTime());
		}
		
	}
	
	@Override
	public void hostsDisconnected(DTNHost host1, DTNHost host2) {
		// start counting time to next connection
		this.addConnection(host1, host2);
	}
}
