/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package routing.contact;

import core.DTNHost;

/**
 *
 * @author Yusuf Sarwar
 */
public class Contact
{
    private DTNHost hostA, hostB;
    public Contact()
    {
        hostA = null;
        hostB = null;
    }
    
    public Contact(DTNHost a, DTNHost b)
    {            
        //if (a.getAddress() < b.getAddress())
        {
            this.hostA = a;
            this.hostB = b;
        }
        /*
        else
        {   
            this.hostA = b;
            this.hostB = a;
        } 
         */       
    }
    
    public Contact(Contact c)
    {
        this(c.getHostA(), c.getHostB());        
    }
    
    public DTNHost getHostA()
    {
        return hostA;
    }
    
    public DTNHost getHostB()
    {
        return hostB;
    }
    
    public boolean equals(Contact other)
    {
        if (hostA == null || hostB == null) return false;
        return ( other.getHostA().equals(hostA) && other.getHostB().equals(hostB) )
                || (other.getHostA().equals(hostB) && other.getHostB().equals(hostA));
    }
    
    public String getKey()
    {
        return "(" +hostA.getAddress() + ", " + hostB.getAddress() +")"; 
    }
    
    public boolean containsHost(DTNHost host)
    {
        return host.equals(this.getHostA()) || host.equals(this.getHostB());
    }
    
    public DTNHost otherHost(DTNHost host)
    {
        if (this.getHostA().equals(host)) return this.getHostB();
        if (this.getHostB().equals(host)) return this.getHostA();
        return null;
    }
    
    @Override
    public String toString()
    {
        return String.format("(%2d, %2d)", hostA.getAddress(), hostB.getAddress());
    }    
}