/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package routing.contact;

/**
 *
 * @author Yusuf Sarwar
 */
public class DualContact
{
    private Contact first, second;
    
    public DualContact()
    {
        first = null;
        second = null;
    }
    
    public DualContact(Contact f, Contact s)
    {
        first = f;
        second = s;
    }
    
    public DualContact(DualContact dc)
    {
        this(new Contact(dc.getFirst()),new Contact(dc.getSecond()));
    }
    
    public Contact getFirst()
    {
        return first;
    }
    
    public Contact getSecond()
    {
        return second;
    }
    
    @Override
    public boolean equals(Object obj)
    {
        assert obj instanceof DualContact : "DualContact is tried to match to another type object";     
        
        DualContact otherDual = (DualContact)obj;
        return otherDual.equals(this);

    }

    @Override
    public int hashCode() {
        int hash = 5;
        return hash;
    }
    public boolean equals(DualContact other)
    {
        if (first == null || second == null) return false;       
        //System.out.println("Checking " + this + " with  " + other);
        return first.equals(other.getFirst()) && second.equals(other.getSecond());        
    }
     
    public String getKey()
    {
        return first.getKey() + "->" + second.getKey();
    }
    
    @Override
    public String toString()
    {
        return getKey();
    }        
}
