/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package routing.contact;

/**
 *
 * @author Yusuf Sarwar
 */
public class NextContactEntry
{
    private Contact nextContact;
    private int contactCounter;
    private double delay;
    
    public NextContactEntry()
    {
        nextContact = null;
        delay = Double.MAX_VALUE;
    }
    
    public NextContactEntry(Contact nc, int count, double d)
    {
        nextContact = nc;
        contactCounter = count;
        delay = d;
    }
    
    public NextContactEntry(NextContactEntry nc)
    {
        nextContact = new Contact(nc.getNextContact());
        contactCounter = nc.contactCounter;
        delay = nc.getDelay();
    }
    
    public Contact getNextContact()
    {
        return nextContact;
    }
    
    public int getContactCounter()
    {
        return contactCounter;
    }
    
    public double getDelay()
    {
        return delay;
    }
    
    public void setNextContact(Contact c)
    {
        nextContact = c;
    }
    
    public void setContactCounter(int count)
    {
        this.contactCounter = count;
    }
    
    public void setDelay(double d)
    {
        delay = d;
    }
    
    @Override
    public String toString()
    {
        return this.getNextContact() + " : " + this.getDelay();
    }    
}

