/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package routing.contact;

/**
 *
 * @author Yusuf Sarwar
 */
public class PeerEventEntry{
    private double delay;
    private int count;
    private double quality;
    private double variance;
    
    private final double delay_max = 1000;
    
    public PeerEventEntry()
    {
        delay = Double.MAX_VALUE;
        count = 0;
        quality = 0.0;     
        variance = Double.MAX_VALUE;
    }
    
    public PeerEventEntry(double c, int n, double q, double v)
    {
        this.delay = c;
        this.count = n;
        this.quality = q;
        this.variance = v;
    }
    
    public void appendNewDelay(double delay)
    {
        delay = 1.0 * delay * count / (count + 1) + (1.0 * delay_max) / (count + 1);
        if (count > 1)
            variance = 1.0 * (count - 1) * variance / count + delay * delay / count;
        count = count + 1;
        
    }
    public void setDelay(double c)
    {
        this.delay = c;        
    }
    
    public void setCount(int n)
    {
        this.count = n;
    }
    
    public void setQuality(double q)
    {
        this.quality = q;
    }
    
    public double getDelay()
    {
        return delay;
    }
            
    public double getQuality()
    {
        return quality;
    }
    
    public int getCount()
    {
        return count;
    }
    
    public String toString()
    {
        return "[" + count + "  " + delay + "]";
    }
}
